diff --git a/test/simpleobsoletestests.py b/test/simpleobsoletestests.py
index 05ebf05..035970c 100644
--- a/test/simpleobsoletestests.py
+++ b/test/simpleobsoletestests.py
@@ -217,6 +217,119 @@ class SimpleObsoletesTests(OperationsTests):
         self.assertResult((p.obsoletes_i386, p.obsoletes_x86_64, p.requires_obsoletes))
 
 
+    def testInstallObsoletenoarchTonoarch(self):
+        p = self.pkgs
+        res, msg = self.runOperation(['install', 'zsh-ng'], [p.installed_noarch], [p.obsoletes_noarch])
+        self.assert_(res=='ok', msg)
+        self.assertResult((p.obsoletes_noarch,))
+
+    def _MultiObsHelper(self):
+        ret = {'zsh'  : FakePackage('zsh', '1', '1', '0', 'noarch'),
+               'ksh'  : FakePackage('ksh', '1', '1', '0', 'noarch'),
+               'nash' : FakePackage('nash', '1', '1', '0', 'noarch')}
+        ret['pi'] = [ret['zsh'], ret['ksh'], ret['nash']]
+              
+        ret['fish'] = FakePackage('fish', '0.1', '1', '0', 'noarch')
+        ret['fish'].addObsoletes('zsh', None, (None, None, None))
+        ret['bigfish'] = FakePackage('bigfish', '0.2', '1', '0', 'noarch')
+        ret['bigfish'].addObsoletes('zsh', None, (None, None, None))
+        ret['bigfish'].addObsoletes('ksh', None, (None, None, None))
+        ret['shark'] = FakePackage('shark', '0.3', '1', '0', 'noarch')
+        ret['shark'].addObsoletes('zsh', None, (None, None, None))
+        ret['shark'].addObsoletes('ksh', None, (None, None, None))
+        ret['shark'].addObsoletes('nash', None, (None, None, None))
+
+        ret['po'] = [ret['fish'], ret['bigfish'], ret['shark']]
+        return ret
+
+    def testMultiObs1(self):
+        pkgs = self._MultiObsHelper()
+        res, msg = self.runOperation(['install', 'fish'],
+                                     pkgs['pi'], pkgs['po'])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pkgs['ksh'],pkgs['nash'],pkgs['fish'],))
+
+    def testMultiObs2(self):
+        pkgs = self._MultiObsHelper()
+        res, msg = self.runOperation(['install', 'bigfish'],
+                                     pkgs['pi'], pkgs['po'])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pkgs['nash'],pkgs['bigfish'],))
+
+    def testMultiObs3(self):
+        pkgs = self._MultiObsHelper()
+        res, msg = self.runOperation(['install', 'shark'],
+                                     pkgs['pi'], pkgs['po'])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pkgs['shark'],))
+
+    def testMultiObs4(self):
+        # This tests update...
+        pkgs = self._MultiObsHelper()
+        oldshark = FakePackage('shark', '0.1', '1', '0', 'noarch')
+
+        res, msg = self.runOperation(['update', 'shark'],
+                                     pkgs['pi'] + [oldshark], pkgs['po'])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pkgs['shark'],))
+
+    def testMultiObs5(self):
+        # This tests update of the to be obsoleted pkg...
+        pkgs = self._MultiObsHelper()
+        oldshark = FakePackage('shark', '0.1', '1', '0', 'noarch')
+
+        res, msg = self.runOperation(['update', 'nash'],
+                                     pkgs['pi'] + [oldshark], pkgs['po'])
+        self.assert_(res=='ok', msg)
+        self.assertResult((pkgs['shark'],))
+
+    # NOTE: Do we really want to remove the old kernel-xen? ... not 100% sure
+    def testMultiObsKern1(self):
+        # kernel + kernel-xen installed, and update kernel obsoletes kernel-xen
+        okern1    = FakePackage('kernel',     '0.1', '1', '0', 'noarch')
+        okern2    = FakePackage('kernel',     '0.2', '1', '0', 'noarch')
+        okernxen1 = FakePackage('kernel-xen', '0.1', '1', '0', 'noarch')
+        okernxen2 = FakePackage('kernel-xen', '0.2', '1', '0', 'noarch')
+        nkern     = FakePackage('kernel',     '0.8', '1', '0', 'noarch')
+        nkern.addObsoletes('kernel-xen', None, (None, None, None))
+
+        res, msg = self.runOperation(['update', 'kernel'],
+                                     [okern1, okernxen1,
+                                      okern2, okernxen2], [nkern])
+        self.assert_(res=='ok', msg)
+        self.assertResult((okern1,okern2,nkern,))
+
+    def testMultiObsKern2(self):
+        # kernel + kernel-xen installed, and update kernel obsoletes kernel-xen
+        okern1    = FakePackage('kernel',     '0.1', '1', '0', 'noarch')
+        okern2    = FakePackage('kernel',     '0.2', '1', '0', 'noarch')
+        okernxen1 = FakePackage('kernel-xen', '0.1', '1', '0', 'noarch')
+        okernxen2 = FakePackage('kernel-xen', '0.2', '1', '0', 'noarch')
+        nkern     = FakePackage('kernel',     '0.8', '1', '0', 'noarch')
+        nkern.addObsoletes('kernel-xen', None, (None, None, None))
+
+        res, msg = self.runOperation(['update', 'kernel-xen'],
+                                     [okern1, okernxen1,
+                                      okern2, okernxen2], [nkern])
+        self.assert_(res=='ok', msg)
+        self.assertResult((okern1,okern2,nkern,))
+
+    def testMultiObsKern3(self):
+        # kernel + kernel-xen installed, and update kernel obsoletes kernel-xen
+        okern1    = FakePackage('kernel',     '0.1', '1', '0', 'noarch')
+        okern2    = FakePackage('kernel',     '0.2', '1', '0', 'noarch')
+        okernxen1 = FakePackage('kernel-xen', '0.1', '1', '0', 'noarch')
+        okernxen2 = FakePackage('kernel-xen', '0.2', '1', '0', 'noarch')
+        nkern     = FakePackage('kernel',     '0.8', '1', '0', 'noarch')
+        nkern.addObsoletes('kernel-xen', None, (None, None, None))
+
+        res, msg = self.runOperation(['update'],
+                                     [okern1, okernxen1,
+                                      okern2, okernxen2], [nkern])
+        self.assert_(res=='ok', msg)
+        self.assertResult((okern1,okern2,nkern,))
+
+
 class GitMetapackageObsoletesTests(OperationsTests):
 
     @staticmethod
diff --git a/test/simpleupdatetests.py b/test/simpleupdatetests.py
index 4efe382..10ddd4f 100644
--- a/test/simpleupdatetests.py
+++ b/test/simpleupdatetests.py
@@ -92,9 +92,9 @@ class SimpleUpdateTests(OperationsTests):
         p = self.pkgs
         res, msg = self.runOperation(['update'], [p.installed_noarch], [p.update_i386, p.update_x86_64])
         self.assert_(res=='ok', msg)
-        if new_behavior:
+        if True or new_behavior: # We update from .noarch to just the .x86_64
             self.assertResult((p.update_x86_64,), (p.update_i386,)) # ?
-        else:
+        else: # Updates to both...
             self.assertResult((p.update_i386, p.update_x86_64))
     def testUpdatenoarchToMultilibForDependencyRev(self):
         p = self.pkgs
@@ -360,3 +360,122 @@ class SimpleUpdateTests(OperationsTests):
         res, msg = self.runOperation(['install', 'foo'], [foo11, bar11], [foo12, bar12, bar21])
         self.assert_(res=='ok', msg)
         self.assertResult((foo12, bar12))
+
+    def testUpdateBadMultiInstall1(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+
+        res, msg = self.runOperation(['install', 'foo'],
+                                     [foo11, foo12, foo13],
+                                     [foo20])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,))
+
+    def testUpdateBadMultiInstall2(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+
+        res, msg = self.runOperation(['update', 'foo'],
+                                     [foo11, foo12, foo13],
+                                     [foo20])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,))
+
+    def testUpdateBadMultiInstall3(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+
+        res, msg = self.runOperation(['update'],
+                                     [foo11, foo12, foo13],
+                                     [foo20])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,))
+
+    def testUpdateBadMultiInstall4(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addRequires('foo', 'EQ', ('0', '2', '0'))
+
+        res, msg = self.runOperation(['update', 'bar'],
+                                     [foo11, foo12, foo13, bar11],
+                                     [foo20, bar12])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,bar12))
+
+    def testUpdateBadMultiInstall5(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addRequires('foo', 'EQ', ('0', '2', '0'))
+
+        res, msg = self.runOperation(['update'],
+                                     [foo11, foo12, foo13, bar11],
+                                     [foo20, bar12])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,bar12))
+
+    def testUpdateBadMultiInstall6(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addObsoletes('foo', None, (None, None, None))
+
+        res, msg = self.runOperation(['update'],
+                                     [foo11, foo12, foo13, bar11],
+                                     [foo20, bar12])
+        self.assert_(res=='ok', msg)
+        self.assertResult((bar12,))
+
+    def testUpdateBadMultiInstall7(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addRequires('foo', 'EQ', ('0', '2', '0'))
+
+        res, msg = self.runOperation(['update', '*'],
+                                     [foo11, foo12, foo13, bar11],
+                                     [foo20, bar12])
+        self.assert_(res=='ok', msg)
+        self.assertResult((foo20,bar12))
+
+    def testUpdateBadMultiInstall8(self):
+        # This is a bug, but we shouldn't die too badly on it...
+        foo11 = FakePackage('foo', '1', '1', '0', 'i386')
+        foo12 = FakePackage('foo', '1', '2', '0', 'i386')
+        foo13 = FakePackage('foo', '1', '3', '0', 'i386')
+        foo20 = FakePackage('foo', '2', '0', '0', 'i386')
+        bar11 = FakePackage('bar', '1', '1', '0', 'i386')
+        bar12 = FakePackage('bar', '1', '2', '0', 'i386')
+        bar12.addObsoletes('foo', None, (None, None, None))
+
+        res, msg = self.runOperation(['update', '*'],
+                                     [foo11, foo12, foo13, bar11],
+                                     [foo20, bar12])
+        self.assert_(res=='ok', msg)
+        self.assertResult((bar12,))
diff --git a/test/skipbroken-tests.py b/test/skipbroken-tests.py
index 7af855e..d6f763c 100644
--- a/test/skipbroken-tests.py
+++ b/test/skipbroken-tests.py
@@ -378,35 +378,210 @@ class SkipBrokenTests(DepsolveTests):
         po2.addProvides('barlib', 'EQ', ('0', '2', '0'))
         po3 = self.repoPackage('zap', '2')
         po3.addRequires('barlib', 'EQ', ('0', '2', '0'))
+        #FIXME: Find out why this line is needed, it should be auto updated by the solver.
         self.tsInfo.addUpdate(po1, oldpo=ipo1) # why is this needed, it should work without ?
         self.tsInfo.addUpdate(po3, oldpo=ipo3)
         self.assertEquals('ok', *self.resolveCode(skip=True))
         self.assertResult([po1,po2,po3])               
 
-    def testInstReqOldVer2(self):
-    	""" 
-    	zap-2.0 updates zap-1.0, but zap-2.0 needs barlib-2.0 provided by
-    	bar-2.0, but the installed foo, needs barlib-1.0,  so it need to be updated to
-    	foo-2.0, that requires barlib-2.0
-    	But it only work if foo-1.0 -> foo-2.0 is added as an update, it is not 
-    	pulled in by it self.
-    	FIXME: This test case will fail for now 
-    	"""
-        ipo1 = self.instPackage('foo', '1')
-        ipo1.addRequires('barlib', 'EQ', ('0', '1', '0'))
-        ipo2 = self.instPackage('bar', '1')
-        ipo2.addProvides('barlib', 'EQ', ('0', '1', '0'))
-        ipo3 = self.instPackage('zap', '1')
-        po1 = self.repoPackage('foo', '2')
-        po1.addRequires('barlib', 'EQ', ('0', '2', '0'))
-        po2 = self.repoPackage('bar', '2')
-        po2.addProvides('barlib', 'EQ', ('0', '2', '0'))
-        po3 = self.repoPackage('zap', '2')
-        po3.addRequires('barlib', 'EQ', ('0', '2', '0'))
-        #self.tsInfo.addUpdate(po1, oldpo=ipo1) # why is this needed, it should work without ?
-        self.tsInfo.addUpdate(po3, oldpo=ipo3)
+
+    def testBumpedSoName1(self):
+        """ 
+        d2 need a lib from b1, so the update fails.
+        d2 and b2 get skipped, but the installed b1 needs a
+        lib from a1, but it has been updated to a2, so it is
+        no longer there. so a2 needs to be skipped to
+        """
+        a1 = self.instPackage('a', '1', arch='x86_64')
+        a1.addProvides("liba.so.1()(64bit)")
+        a2 = self.repoPackage('a', '2', arch='x86_64')
+        a2.addProvides("liba.so.2()(64bit)")
+        
+        b1 = self.instPackage('b', '1', arch='x86_64')
+        b1.addProvides("libb.so.1()(64bit)")
+        b1.addRequires("liba.so.1()(64bit)")
+        b2 = self.repoPackage('b', '2', arch='x86_64')
+        b2.addProvides("libb.so.2()(64bit)")
+        b2.addRequires("liba.so.2()(64bit)")
+        
+        c1 = self.instPackage('c', '1', arch='x86_64')
+        c1.addRequires("liba.so.1()(64bit)")
+        c2 = self.repoPackage('c', '2', arch='x86_64')
+        c2.addRequires("liba.so.2()(64bit)")
+
+        d1 = self.instPackage('d', '1', arch='x86_64')
+        d1.addRequires("libb.so.1()(64bit)")
+        d2 = self.repoPackage('d', '2', arch='x86_64')
+        d2.addRequires("libb.so.1()(64bit)")
+
+        e1 = self.instPackage('e', '1', arch='x86_64')
+        e2 = self.repoPackage('e', '2', arch='x86_64')
+
+        f1 = self.instPackage('f', '1', arch='x86_64')
+        f2 = self.repoPackage('f', '2', arch='x86_64')
+
+        self.tsInfo.addUpdate(a2, oldpo=a1)
+        self.tsInfo.addUpdate(b2, oldpo=b1)
+        self.tsInfo.addUpdate(c2, oldpo=c1)
+        self.tsInfo.addUpdate(d2, oldpo=d1)
+        self.tsInfo.addUpdate(e2, oldpo=e1)
+        self.tsInfo.addUpdate(f2, oldpo=f1)
         self.assertEquals('ok', *self.resolveCode(skip=True))
-        self.assertResult([po1,po2,po3])               
+        self.assertResult([a1,b1,c1,d1,e2,f2])
+
+    def testBumpedSoName2(self):
+        """ 
+        https://bugzilla.redhat.com/show_bug.cgi?id=468785
+        """
+        c1 = self.instPackage('cyrus-sasl-lib', '2.1.22',"18")
+        c1.addRequires("libdb-4.3.so")
+        
+        d1 = self.instPackage('compat-db', '4.6.21',"4")
+        d1.addProvides("libdb-4.3.so")
+        od1 = self.repoPackage('compat-db46', '4.6.21',"5")
+        od1.addProvides("libdb-4.6.so")
+        od1.addObsoletes("compat-db")
+        od2 = self.repoPackage('compat-db45', '4.6.21',"5")
+        od2.addProvides("libdb-4.5.so")
+        od2.addObsoletes("compat-db")
+        
+        r1 = self.instPackage('rpm', '4.6.0-0','0.rc1.3')
+        r1.addRequires("libdb-4.5.so")
+        r2 = self.instPackage('rpm-libs', '4.6.0-0','0.rc1.3')
+        r2.addRequires("libdb-4.5.so")
+        r3 = self.instPackage('rpm-build', '4.6.0-0','0.rc1.3')
+        r3.addRequires("libdb-4.5.so")
+        r4 = self.instPackage('rpm-python', '4.6.0-0','0.rc1.3')
+        r4.addRequires("libdb-4.5.so")
+
+        ur1 = self.repoPackage('rpm', '4.6.0-0','0.rc1.5')
+        ur1.addRequires("libdb-4.5.so")
+        ur1.addRequires("compat-db45")
+        ur2 = self.repoPackage('rpm-libs', '4.6.0-0','0.rc1.5')
+        ur2.addRequires("libdb-4.5.so")
+        ur2.addRequires("compat-db45")
+        ur3 = self.repoPackage('rpm-build', '4.6.0-0','0.rc1.5')
+        ur3.addRequires("libdb-4.5.so")
+        ur3.addRequires("compat-db45")
+        ur4 = self.repoPackage('rpm-python', '4.6.0-0','0.rc1.5')
+        ur4.addRequires("libdb-4.5.so")
+        ur4.addRequires("compat-db45")
+
+        self.tsInfo.addObsoleting(od2, oldpo=d1)
+        self.tsInfo.addObsoleted(d1, od2)
+        self.tsInfo.addObsoleting(od1, oldpo=d1)
+        self.tsInfo.addObsoleted(d1, od1)
+        self.tsInfo.addUpdate(ur1, oldpo=r1)
+        self.tsInfo.addUpdate(ur2, oldpo=r2)
+        self.tsInfo.addUpdate(ur3, oldpo=r3)
+        self.tsInfo.addUpdate(ur4, oldpo=r4)
+        
+        self.assertEquals('empty', *self.resolveCode(skip=True))
+        self.assertResult([c1,d1,r1,r2,r3,r4])
+
+    def testBumpedSoName3(self):
+        """ 
+        https://bugzilla.redhat.com/show_bug.cgi?id=468785
+        yum update compat-db46
+        """
+        c1 = self.instPackage('cyrus-sasl-lib', '2.1.22',"18")
+        c1.addRequires("libdb-4.3.so")
+        
+        d1 = self.instPackage('compat-db', '4.6.21',"4")
+        d1.addProvides("libdb-4.3.so")
+        od1 = self.repoPackage('compat-db46', '4.6.21',"5")
+        od1.addProvides("libdb-4.6.so")
+        od1.addObsoletes("compat-db")
+        od2 = self.repoPackage('compat-db45', '4.6.21',"5")
+        od2.addProvides("libdb-4.5.so")
+        od2.addObsoletes("compat-db")
+        
+        r1 = self.instPackage('rpm', '4.6.0-0','0.rc1.3')
+        r1.addRequires("libdb-4.5.so")
+        r2 = self.instPackage('rpm-libs', '4.6.0-0','0.rc1.3')
+        r2.addRequires("libdb-4.5.so")
+        r3 = self.instPackage('rpm-build', '4.6.0-0','0.rc1.3')
+        r3.addRequires("libdb-4.5.so")
+        r4 = self.instPackage('rpm-python', '4.6.0-0','0.rc1.3')
+        r4.addRequires("libdb-4.5.so")
+
+        ur1 = self.repoPackage('rpm', '4.6.0-0','0.rc1.5')
+        ur1.addRequires("libdb-4.5.so")
+        ur1.addRequires("compat-db45")
+        ur2 = self.repoPackage('rpm-libs', '4.6.0-0','0.rc1.5')
+        ur2.addRequires("libdb-4.5.so")
+        ur2.addRequires("compat-db45")
+        ur3 = self.repoPackage('rpm-build', '4.6.0-0','0.rc1.5')
+        ur3.addRequires("libdb-4.5.so")
+        ur3.addRequires("compat-db45")
+        ur4 = self.repoPackage('rpm-python', '4.6.0-0','0.rc1.5')
+        ur4.addRequires("libdb-4.5.so")
+        ur4.addRequires("compat-db45")
+
+        self.tsInfo.addObsoleting(od1, oldpo=d1)
+        self.tsInfo.addObsoleted(d1, od1)
+        self.tsInfo.addUpdate(ur1, oldpo=r1)
+        self.tsInfo.addUpdate(ur2, oldpo=r2)
+        self.tsInfo.addUpdate(ur3, oldpo=r3)
+        self.tsInfo.addUpdate(ur4, oldpo=r4)
+        
+        self.assertEquals('err', *self.resolveCode(skip=False))
+        
+    def testBumpedSoNameMultiArch(self):
+        """ 
+        if compat-db45.x86_64 get skipped, then compat-db45.i386 should not 
+        get pulled in instead
+        """
+        c1 = self.instPackage('cyrus-sasl-lib', '2.1.22',"18", arch='x86_64')
+        c1.addRequires("libdb-4.3.so")
+        
+        d1 = self.instPackage('compat-db', '4.6.21',"4", arch='x86_64')
+        d1.addProvides("libdb-4.3.so")
+        od1 = self.repoPackage('compat-db46', '4.6.21',"5", arch='x86_64')
+        od1.addProvides("libdb-4.6.so")
+        od1.addObsoletes("compat-db")
+        od2 = self.repoPackage('compat-db45', '4.6.21',"5", arch='x86_64')
+        od2.addProvides("libdb-4.5.so")
+        od2.addObsoletes("compat-db")
+        od3 = self.repoPackage('compat-db45', '4.6.21',"5", arch='i386')
+        od3.addProvides("libdb-4.5.so")
+        od3.addObsoletes("compat-db")
+        
+        r1 = self.instPackage('rpm', '4.6.0-0','0.rc1.3', arch='x86_64')
+        r1.addRequires("libdb-4.5.so")
+        r2 = self.instPackage('rpm-libs', '4.6.0-0','0.rc1.3', arch='x86_64')
+        r2.addRequires("libdb-4.5.so")
+        r3 = self.instPackage('rpm-build', '4.6.0-0','0.rc1.3', arch='x86_64')
+        r3.addRequires("libdb-4.5.so")
+        r4 = self.instPackage('rpm-python', '4.6.0-0','0.rc1.3', arch='x86_64')
+        r4.addRequires("libdb-4.5.so")
+
+        ur1 = self.repoPackage('rpm', '4.6.0-0','0.rc1.5', arch='x86_64')
+        ur1.addRequires("libdb-4.5.so")
+        ur1.addRequires("compat-db45")
+        ur2 = self.repoPackage('rpm-libs', '4.6.0-0','0.rc1.5', arch='x86_64')
+        ur2.addRequires("libdb-4.5.so")
+        ur2.addRequires("compat-db45")
+        ur3 = self.repoPackage('rpm-build', '4.6.0-0','0.rc1.5', arch='x86_64')
+        ur3.addRequires("libdb-4.5.so")
+        ur3.addRequires("compat-db45")
+        ur4 = self.repoPackage('rpm-python', '4.6.0-0','0.rc1.5', arch='x86_64')
+        ur4.addRequires("libdb-4.5.so")
+        ur4.addRequires("compat-db45")
+
+
+        self.tsInfo.addObsoleting(od2, oldpo=d1)
+        self.tsInfo.addObsoleted(d1, od2)
+        self.tsInfo.addObsoleting(od1, oldpo=d1)
+        self.tsInfo.addObsoleted(d1, od1)
+        self.tsInfo.addUpdate(ur1, oldpo=r1)
+        self.tsInfo.addUpdate(ur2, oldpo=r2)
+        self.tsInfo.addUpdate(ur3, oldpo=r3)
+        self.tsInfo.addUpdate(ur4, oldpo=r4)
+
+        self.assertEquals('empty', *self.resolveCode(skip=True))
+        self.assertResult([c1,d1,r1,r2,r3,r4])
+        
     
     def resolveCode(self,skip = False):
         solver = YumBase()
@@ -415,6 +590,7 @@ class SkipBrokenTests(DepsolveTests):
         solver.tsInfo = solver._tsInfo = self.tsInfo
         solver.rpmdb = self.rpmdb
         solver.pkgSack = self.xsack
+        solver.dsCallback = DepSolveProgressCallBack()
         
         for po in self.rpmdb:
             po.repoid = po.repo.id = "installed"
@@ -438,4 +614,3 @@ def setup_logging():
     verbose.propagate = False
     verbose.addHandler(console_stdout)
     verbose.setLevel(2)
-
diff --git a/test/testbase.py b/test/testbase.py
index ccab847..d0ff1c3 100644
--- a/test/testbase.py
+++ b/test/testbase.py
@@ -3,6 +3,8 @@ import sys
 import unittest
 
 import settestpath
+import logging
+import yum.logginglevels as logginglevels
 
 new_behavior = "NEW_BEHAVIOR" in os.environ.keys()
 
@@ -19,6 +21,10 @@ from rpmUtils import arch
 ### Helper classes ##########################################
 #############################################################
 
+# Dummy translation wrapper
+def _(msg):
+    return msg
+
 class FakeConf(object):
 
     def __init__(self):
@@ -35,6 +41,7 @@ class FakeConf(object):
         self.disable_excludes = []
         self.multilib_policy = 'best'
         self.persistdir = '/should-not-exist-bad-test!'
+        self.showdupesfromrepos = False
 
 class FakeRepo(object):
 
@@ -81,6 +88,65 @@ class _Container(object):
     pass
 
 
+class DepSolveProgressCallBack:
+    """provides text output callback functions for Dependency Solver callback"""
+    
+    def __init__(self):
+        """requires yum-cli log and errorlog functions as arguments"""
+        self.verbose_logger = logging.getLogger("yum.verbose.cli")
+        self.loops = 0
+    
+    def pkgAdded(self, pkgtup, mode):
+        modedict = { 'i': _('installed'),
+                     'u': _('updated'),
+                     'o': _('obsoleted'),
+                     'e': _('erased')}
+        (n, a, e, v, r) = pkgtup
+        modeterm = modedict[mode]
+        self.verbose_logger.log(logginglevels.INFO_2,
+            _('---> Package %s.%s %s:%s-%s set to be %s'), n, a, e, v, r,
+            modeterm)
+        
+    def start(self):
+        self.loops += 1
+        
+    def tscheck(self):
+        self.verbose_logger.log(logginglevels.INFO_2, _('--> Running transaction check'))
+        
+    def restartLoop(self):
+        self.loops += 1
+        self.verbose_logger.log(logginglevels.INFO_2,
+            _('--> Restarting Dependency Resolution with new changes.'))
+        self.verbose_logger.debug('---> Loop Number: %d', self.loops)
+    
+    def end(self):
+        self.verbose_logger.log(logginglevels.INFO_2,
+            _('--> Finished Dependency Resolution'))
+
+    
+    def procReq(self, name, formatted_req):
+        self.verbose_logger.log(logginglevels.INFO_2,
+            _('--> Processing Dependency: %s for package: %s'), formatted_req,
+            name)
+        
+    
+    def unresolved(self, msg):
+        self.verbose_logger.log(logginglevels.INFO_2, _('--> Unresolved Dependency: %s'),
+            msg)
+
+    
+    def procConflict(self, name, confname):
+        self.verbose_logger.log(logginglevels.INFO_2,
+            _('--> Processing Conflict: %s conflicts %s'), name, confname)
+
+    def transactionPopulation(self):
+        self.verbose_logger.log(logginglevels.INFO_2, _('--> Populating transaction set '
+            'with selected packages. Please wait.'))
+    
+    def downloadHeader(self, name):
+        self.verbose_logger.log(logginglevels.INFO_2, _('---> Downloading header for %s '
+            'to pack into transaction set.'), name)
+      
 #######################################################################
 ### Abstract super class for test cases ###############################
 #######################################################################
@@ -145,6 +211,35 @@ class _DepsolveTestsBase(unittest.TestCase):
             errors.append("\n")
             self.fail("".join(errors))
 
+class FakeRpmDb(packageSack.PackageSack):
+    '''
+    We use a PackagePack for a Fake rpmdb insted of the normal
+    RPMDBPackageSack, getProvides works a little different on
+    unversioned requirements so we have to overload an add some
+    extra checkcode.
+    '''
+    def __init__(self):
+        packageSack.PackageSack.__init__(self)
+
+    def getProvides(self, name, flags=None, version=(None, None, None)):
+        """return dict { packages -> list of matching provides }"""
+        self._checkIndexes(failure='build')
+        result = { }
+        # convert flags & version for unversioned reqirements
+        if not version:
+            version=(None, None, None)
+        if flags == '0':
+            flags=None
+        for po in self.provides.get(name, []):
+            hits = po.matchingPrcos('provides', (name, flags, version))
+            if hits:
+                result[po] = hits
+        if name[0] == '/':
+            hit = (name, None, (None, None, None))
+            for po in self.searchFiles(name):
+                result.setdefault(po, []).append(hit)
+        return result
+            
 
 #######################################################################
 ### Derive Tests from these classes or unittest.TestCase ##############
@@ -173,12 +268,17 @@ class DepsolveTests(_DepsolveTestsBase):
         """ Called at the start of each test. """
         _DepsolveTestsBase.setUp(self)
         self.tsInfo = transactioninfo.TransactionData()
-        self.rpmdb  = packageSack.PackageSack()
+        self.tsInfo.debug = 1
+        self.rpmdb  = FakeRpmDb()
         self.xsack  = packageSack.PackageSack()
         self.repo   = FakeRepo("installed")
         # XXX this side-affect is hacky:
         self.tsInfo.setDatabases(self.rpmdb, self.xsack)
 
+    def resetTsInfo(self):
+        self.tsInfo = transactioninfo.TransactionData()
+        
+
     def resolveCode(self):
         solver = YumBase()
         solver.conf = FakeConf()
diff --git a/utils.py b/utils.py
index d92f533..cea9110 100644
--- a/utils.py
+++ b/utils.py
@@ -61,12 +61,20 @@ class YumUtilBase(YumBaseCli):
         root = self._parser.getRoot(opts)
         # Read up configuration options and initialise plugins
         try:
+            disabled_plugins = None
+            if hasattr(opts, "disableplugins"):
+                disabled_plugins = self._parser._splitArg(opts.disableplugins)
+            enabled_plugins  = None
+            if hasattr(opts, "enableplugins"):
+                enabled_plugins = self._parser._splitArg(opts.enableplugins)
             self._getConfig(opts.conffile, root, 
                     init_plugins=not opts.noplugins,
                     plugin_types= pluginsTypes,
                     optparser=self._parser,
                     debuglevel=opts.debuglevel,
-                    errorlevel=opts.errorlevel)
+                    errorlevel=opts.errorlevel,
+                    disabled_plugins=disabled_plugins,
+                    enabled_plugins=enabled_plugins)
         except yum.Errors.ConfigError, e:
             self.logger.critical(_('Config Error: %s'), e)
             sys.exit(1)
diff --git a/yum/Errors.py b/yum/Errors.py
index 4bccd86..be6bda2 100644
--- a/yum/Errors.py
+++ b/yum/Errors.py
@@ -18,6 +18,8 @@
 Exceptions and Errors thrown by yum.
 """
 
+from i18n import to_unicode
+
 class YumBaseError(Exception):
     """
     Base Yum Error. All other Errors thrown by yum should inherit from
@@ -29,6 +31,9 @@ class YumBaseError(Exception):
     def __str__(self):
         return "%s" %(self.value,)
 
+    def __unicode__(self):
+        return '%s' % to_unicode(self.value)
+
 class YumGPGCheckError(YumBaseError):
     pass
 
